package kr.co.vividnext.sodalive.search

import io.reactivex.rxjava3.core.Single
import kr.co.vividnext.sodalive.common.ApiResponse
import kr.co.vividnext.sodalive.settings.ContentType
import retrofit2.http.GET
import retrofit2.http.Header
import retrofit2.http.Query

interface SearchApi {
    @GET("/search")
    fun searchUnified(
        @Query("keyword") keyword: String,
        @Query("isAdultContentVisible") isAdultContentVisible: Boolean,
        @Query("contentType") contentType: ContentType,
        @Header("Authorization") authHeader: String
    ): Single<ApiResponse<SearchUnifiedResponse>>

    @GET("/search/creators")
    fun searchCreatorList(
        @Query("keyword") keyword: String,
        @Query("isAdultContentVisible") isAdultContentVisible: Boolean,
        @Query("contentType") contentType: ContentType,
        @Query("page") page: Int,
        @Query("size") size: Int,
        @Header("Authorization") authHeader: String
    ): Single<ApiResponse<SearchResponse>>

    @GET("/search/contents")
    fun searchContentList(
        @Query("keyword") keyword: String,
        @Query("isAdultContentVisible") isAdultContentVisible: Boolean,
        @Query("contentType") contentType: ContentType,
        @Query("page") page: Int,
        @Query("size") size: Int,
        @Header("Authorization") authHeader: String
    ): Single<ApiResponse<SearchResponse>>

    @GET("/search/series")
    fun searchSeriesList(
        @Query("keyword") keyword: String,
        @Query("isAdultContentVisible") isAdultContentVisible: Boolean,
        @Query("contentType") contentType: ContentType,
        @Query("page") page: Int,
        @Query("size") size: Int,
        @Header("Authorization") authHeader: String
    ): Single<ApiResponse<SearchResponse>>
}
