package kr.co.vividnext.sodalive.search

import kr.co.vividnext.sodalive.common.SharedPreferenceManager
import kr.co.vividnext.sodalive.settings.ContentType

class SearchRepository(private val api: SearchApi) {
    fun searchUnified(
        keyword: String,
        token: String
    ) = api.searchUnified(
        keyword = keyword,
        isAdultContentVisible = SharedPreferenceManager.isAdultContentVisible,
        contentType = ContentType.values()[SharedPreferenceManager.contentPreference],
        authHeader = token
    )

    fun searchCreatorList(
        keyword: String,
        page: Int,
        size: Int,
        token: String
    ) = api.searchCreatorList(
        keyword = keyword,
        isAdultContentVisible = SharedPreferenceManager.isAdultContentVisible,
        contentType = ContentType.values()[SharedPreferenceManager.contentPreference],
        page = page - 1,
        size = size,
        authHeader = token
    )

    fun searchContentList(
        keyword: String,
        page: Int,
        size: Int,
        token: String
    ) = api.searchContentList(
        keyword = keyword,
        isAdultContentVisible = SharedPreferenceManager.isAdultContentVisible,
        contentType = ContentType.values()[SharedPreferenceManager.contentPreference],
        page = page - 1,
        size = size,
        authHeader = token
    )

    fun searchSeriesList(
        keyword: String,
        page: Int,
        size: Int,
        token: String
    ) = api.searchSeriesList(
        keyword = keyword,
        isAdultContentVisible = SharedPreferenceManager.isAdultContentVisible,
        contentType = ContentType.values()[SharedPreferenceManager.contentPreference],
        page = page - 1,
        size = size,
        authHeader = token
    )
}
