package kr.co.vividnext.sodalive.search

import androidx.annotation.Keep
import com.google.gson.annotations.SerializedName

@Keep
data class SearchUnifiedResponse(
    @SerializedName("creatorList") val creatorList: List<SearchResponseItem>,
    @SerializedName("contentList") val contentList: List<SearchResponseItem>,
    @SerializedName("seriesList") val seriesList: List<SearchResponseItem>
)

@Keep
data class SearchResponse(
    @SerializedName("totalCount") val totalCount: Int,
    @SerializedName("items") val items: List<SearchResponseItem>
)

@Keep
data class SearchResponseItem(
    @SerializedName("id") val id: Long,
    @SerializedName("imageUrl") val imageUrl: String,
    @SerializedName("title") val title: String,
    @SerializedName("nickname") val nickname: String,
    @SerializedName("type") val type: SearchResponseType
)

@Keep
enum class SearchResponseType {
    @SerializedName("CREATOR") CREATOR,
    @SerializedName("CONTENT") CONTENT,
    @SerializedName("SERIES") SERIES
}
